updateCellList = context.updateCellList

portal = context.getPortalObject()
category_tool = portal.portal_categories
quality = category_tool.quality
packing_form = category_tool.packing_form
brand = category_tool.brand
quantity_unit = category_tool.quantity_unit
metric_type = category_tool.metric_type


product = context.product_module.newContent(
  portal_type='Product',
  title=title,
  quantity_unit_value=quantity_unit.unit.piece,
  variation_base_category_list=[quality.getId(),
                                packing_form.getId(),
                                brand.getId()],
  )
product.setVariationCategoryList([
  category.getRelativeUrl()
  for category in (packing_form.package,
                   packing_form.case,
                   quality.good,
                   quality.bad,
                   getattr(brand, 'brand%s' % str(random.randint(0, 99)).zfill(3)))
  ])
measure_for_package = product.newContent(portal_type='Measure')
measure_for_package.edit(
  quantity_unit_value=quantity_unit.unit.piece,
  metric_type_value=metric_type.unit.package,
  measure_variation_base_category=packing_form.getId())
updateCellList(portal,
               measure_for_package,
               'Measure Cell',
               lambda :[measure_for_package.getVariationRangeCategoryItemList(0),measure_for_package.getVariationRangeCategoryItemList(1),measure_for_package.getVariationRangeCategoryItemList(2)],
               ({'base_id':'cell',
                 'mapped_value_argument_list':('quantity',),
                 'table':(('packing_form/case', quantity_per_carton),
                          ('packing_form/package', 1),
                          )
                 },
                ))
measure_for_case = product.newContent(portal_type='Measure')
measure_for_case.edit(
  quantity_unit_value=quantity_unit.unit.piece,
  metric_type_value=metric_type.unit.case,
  measure_variation_base_category=packing_form.getId())
updateCellList(portal,
               measure_for_case,
               'Measure Cell',
               lambda :[measure_for_package.getVariationRangeCategoryItemList(0),measure_for_package.getVariationRangeCategoryItemList(1),measure_for_package.getVariationRangeCategoryItemList(2)],
               ({'base_id':'cell',
                 'mapped_value_argument_list':('quantity',),
                 'table':(('packing_form/case', 1),
                          ('packing_form/package', 1.0/quantity_per_carton),
                          )
                 },
                ))

return product
