now = DateTime()

search_dict = {
  'predicate.start_date_range_min':{'query':now,
                                    'range':'ngt'},
  'predicate.start_date_range_max':{'query':now,
                                    'range':'nlt'}
}

def getInventory(resource_uid, section_uid, node_uid, variation_category_list):
  variation_text = '\n'.join(sorted(variation_category_list))
  result = context.portal_simulation.getFutureInventory(
    resource_uid=resource_uid,
    section_uid=section_uid,
    node_uid=node_uid,
    variation_text=variation_text
    )
  return result

result = []

for brain in context.portal_catalog(
portal_type=('Purchase Supply Line', 'Purchase Supply Cell'),
default_ledger_uid=context.portal_categories.ledger.automated_ordering.getUid(),
validation_state='validated',
**search_dict
):
  supply_path_value = brain.getObject()

  min_stock_in_path_quantity_unit = supply_path_value.getMinStock()

  if not min_stock_in_path_quantity_unit:
    continue

  resource_value = supply_path_value.getResourceValue()
  default_quantity_unit = resource_value.getDefaultQuantityUnit()
  path_quantity_unit = supply_path_value.getQuantityUnit()

  variation_category_list = supply_path_value.getVariationCategoryList()
  future_stock_in_default_quantity_unit = getInventory(resource_value.getUid(), supply_path_value.getDestinationSectionUid(), supply_path_value.getDestinationUid(), variation_category_list)

  if path_quantity_unit != default_quantity_unit:
    future_stock_in_path_quantity_unit = resource_value.convertQuantity(future_stock_in_default_quantity_unit, default_quantity_unit, path_quantity_unit)
  else:
    future_stock_in_path_quantity_unit = future_stock_in_default_quantity_unit

  required_stock_in_path_quantity_unit = min_stock_in_path_quantity_unit - future_stock_in_path_quantity_unit

  if required_stock_in_path_quantity_unit > 0:
    data = dict(
      resource_value=resource_value,
      supply_path_value=supply_path_value,
      path_quantity_unit=path_quantity_unit,
      min_stock_in_path_quantity_unit=min_stock_in_path_quantity_unit,
      future_stock_in_path_quantity_unit=future_stock_in_path_quantity_unit,
      required_stock_in_path_quantity_unit=required_stock_in_path_quantity_unit,
      start_date=DateTime('%s/%s/%s 00:00:00 %s' % (now.year(), now.month(), now.day(), now.timezone()))
      )
    result.append(data)

return result
